<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet
version="1.0"
xmlns:xl="http://www.w3.org/1999/xlink"
xmlns:html="http://www.w3.org/1999/xhtml"
xmlns:bibtex="http://bibtexml.sf.net/"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!--
module :
produce a DocBook 5 from a bibtexml file

update :
$Id$
fplod 2008-05-16T14:49:33Z aedon.locean-ipsl.upmc.fr (Darwin)
add bibtex:book, bibtex:manual and bibtex:misc : biblioset
fplod 2008-05-16T14:32:48Z aedon.locean-ipsl.upmc.fr (Darwin)
bug fix on bibioset
fplod 2008-05-16T10:38:11Z aedon.locean-ipsl.upmc.fr (Darwin)
add parameter order for firstname/surname order in bibtex file
fplod 2008-05-15T13:43:34Z aedon.locean-ipsl.upmc.fr (Darwin)
creation
see external/bibtex2xml.py (which produce input of the file)
updated with
svn co https://bibtexml.svn.sourceforge.net/svnroot/bibtexml/trunk/bibtexml/import/
note that https://bibtexml.svn.sourceforge.net/svnroot/bibtexml/trunk/bibtexconverter-j/src/net/sourceforge/bibtexml/xslt/bibxml2docbook.xsl produce a Docbook 4file and not DocBook 5 as superbib request.
-->

<xsl:output
 method="xml"
 indent="yes"
 encoding="utf-8"
 omit-xml-declaration="no"/>

<xsl:template match="bibtex:file">
<xsl:element name="bibliography">
 <xsl:attribute name="version">5.0</xsl:attribute>
 <xsl:attribute name="xmlns">http://docbook.org/ns/docbook</xsl:attribute>
 <xsl:attribute name="xml:id"><xsl:value-of select="concat('bib',$project,'ref')"/></xsl:attribute>
 <xsl:attribute name="xml:lang"><xsl:value-of select="$lang"/></xsl:attribute>
 <xsl:element name="info">
  <xsl:element name="date">
   <xsl:value-of select="$makedate"/>
  </xsl:element>
 </xsl:element>
 <xsl:apply-templates select="bibtex:entry"/>
</xsl:element>
<xsl:message>
www : You should have a look on firstname and surname to overiding on basic parsing
</xsl:message>
</xsl:template>

<xsl:template match="bibtex:title">
<xsl:element name="title">
 <xsl:value-of select="."/>
</xsl:element>
</xsl:template>

<xsl:template match="bibtex:entry">
<xsl:element name="biblioentry">
 <xsl:attribute name="xml:id"><xsl:value-of select="@id"/></xsl:attribute>
<!--++ key as info element-->
 <xsl:apply-templates select="bibtex:article"/>
 <xsl:apply-templates select="bibtex:book"/>
 <xsl:apply-templates select="bibtex:manual"/>
 <xsl:apply-templates select="bibtex:misc"/>
</xsl:element>
</xsl:template>

<xsl:template match="bibtex:year">
<xsl:element name="pubdate">
 <xsl:value-of select="."/>
</xsl:element>
</xsl:template>

<xsl:template match="bibtex:pages">
<xsl:element name="pagenums">
 <xsl:value-of select="."/>
</xsl:element>
</xsl:template>

<xsl:template match="bibtex:volume">
<xsl:element name="volumenum">
 <xsl:value-of select="."/>
</xsl:element>
</xsl:template>

<xsl:template match="bibtex:edition">
<xsl:element name="edition">
 <xsl:value-of select="."/>
</xsl:element>
</xsl:template>

<xsl:template match="bibtex:journal">
<xsl:element name="title">
 <xsl:value-of select="."/>
</xsl:element>
</xsl:template>

<xsl:template match="bibtex:article">
 <xsl:apply-templates select="bibtex:title"/>
 <xsl:apply-templates select="bibtex:author"/>
 <xsl:apply-templates select="bibtex:doi"/>
 <xsl:apply-templates select="bibtex:isbn"/>
 <xsl:apply-templates select="bibtex:url"/>
<xsl:element name="biblioset">
 <xsl:attribute name="relation"><xsl:value-of select="'journal'"/></xsl:attribute>
 <xsl:apply-templates select="bibtex:journal"/>
 <xsl:apply-templates select="bibtex:publisher"/>
 <xsl:apply-templates select="bibtex:organization"/>
 <xsl:apply-templates select="bibtex:edition"/>
 <xsl:apply-templates select="bibtex:volume"/>
 <xsl:apply-templates select="bibtex:pages"/>
 <xsl:apply-templates select="bibtex:year"/>
</xsl:element>
</xsl:template>

<xsl:template match="bibtex:book">
 <xsl:apply-templates select="bibtex:title"/>
 <xsl:apply-templates select="bibtex:author"/>
 <xsl:apply-templates select="bibtex:isbn"/>
 <xsl:element name="biblioset">
 <!-- ++ book relation is not yet implented in DocBook processing -->
  <xsl:attribute name="relation"><xsl:value-of select="'book'"/></xsl:attribute>
  <xsl:apply-templates select="bibtex:publisher"/>
  <xsl:apply-templates select="bibtex:edition"/>
  <xsl:apply-templates select="bibtex:volume"/>
  <xsl:apply-templates select="bibtex:pages"/>
  <xsl:apply-templates select="bibtex:year"/>
 </xsl:element>
</xsl:template>

<xsl:template match="bibtex:manual">
 <xsl:apply-templates select="bibtex:title"/>
 <xsl:apply-templates select="bibtex:author"/>
 <xsl:element name="biblioset">
 <!-- ++ manual  relation is not yet implented in DocBook processing -->
  <xsl:attribute name="relation"><xsl:value-of select="'manual'"/></xsl:attribute>
  <xsl:apply-templates select="bibtex:year"/>
  <xsl:apply-templates select="bibtex:publisher"/>
  <xsl:apply-templates select="bibtex:organization"/>
 </xsl:element>
 <xsl:apply-templates select="bibtex:url"/>
</xsl:template>

<xsl:template match="bibtex:misc">
 <xsl:apply-templates select="bibtex:title"/>
 <xsl:apply-templates select="bibtex:author"/>
 <xsl:element name="biblioset">
 <!-- can't know precise relation. set to journal-->
  <xsl:attribute name="relation"><xsl:value-of select="'journal'"/></xsl:attribute>
  <xsl:apply-templates select="bibtex:year"/>
 </xsl:element>
 <xsl:apply-templates select="bibtex:url"/>
</xsl:template>


<xsl:template match="bibtex:publisher|bibtex:organization">
<xsl:element name="publisher">
 <xsl:element name="publishername">
  <xsl:value-of select="."/>
 </xsl:element>
</xsl:element>
</xsl:template>

<xsl:template match="bibtex:isbn">
<xsl:element name="biblioid">
 <xsl:attribute name="class"><xsl:value-of select="'isbn'"/></xsl:attribute>
 <xsl:value-of select="."/>
</xsl:element>
</xsl:template>

<xsl:template match="bibtex:doi">
<xsl:element name="biblioid">
 <xsl:attribute name="class"><xsl:value-of select="'doi'"/></xsl:attribute>
 <xsl:value-of select="."/>
</xsl:element>
</xsl:template>

<xsl:template match="bibtex:author">
<xsl:choose>
 <xsl:when test="count(child::bibtex:person) &gt; 0">
  <xsl:element name="authorgroup">
   <xsl:apply-templates select="child::bibtex:person"/>
  </xsl:element>
 </xsl:when>
 <xsl:otherwise>
  <xsl:element name="authorgroup">
   <xsl:element name="author">
    <xsl:element name="personname">
     <xsl:call-template name="personname" select="."/>
    </xsl:element>
   </xsl:element>
  </xsl:element>
 </xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template match="bibtex:person">
<xsl:element name="author">
 <xsl:element name="personname">
  <xsl:call-template name="personname" select="."/>
 </xsl:element>
</xsl:element>
</xsl:template>

<xsl:template name="personname">
<!--
++extremely basic parsing of firstname and surname :
the first blank is used as a delimiter.
-->
<xsl:choose>
 <xsl:when test="$order = 'fs'">
  <xsl:element name="firstname">
   <xsl:value-of select="substring-before(.,' ')"/>
  </xsl:element>
  <xsl:element name="surname">
   <xsl:value-of select="substring-after(.,' ')"/>
  </xsl:element>
 </xsl:when>
 <xsl:when test="$order = 'sf'">
  <xsl:element name="firstname">
   <xsl:value-of select="substring-after(.,' ')"/>
  </xsl:element>
  <xsl:element name="surname">
   <xsl:value-of select="substring-before(.,' ')"/>
  </xsl:element>
 </xsl:when>
 <xsl:otherwise>
  <xsl:message terminate="yes">
  eee : unknow order value : <xsl:value-of select="$order"/>
  </xsl:message>
 </xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template match="bibtex:url">
<xsl:element name="biblioid">
 <xsl:attribute name="class"><xsl:value-of select="'uri'"/></xsl:attribute>
 <xsl:value-of select="."/>
</xsl:element>
</xsl:template>

<xsl:template match="bibtex:key">
<!--++ keywords-->
<xsl:element name="bibliomisc">
 <xsl:attribute name="role"><xsl:value-of select="'key'"/></xsl:attribute>
 <xsl:value-of select="."/>
</xsl:element>
</xsl:template>

</xsl:stylesheet>
